/**
 * Forwarder receivs input on the port and forwards
 * it to another host. First argument given is the
 * target host.
 * @file gnet/network/testing/forwarder.c
 * @author Christian Grothoff
 * @author Larry Waldo
 **/
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <stdio.h>
#include <string.h>

#include "network.h"

#define MESSAGE_SIZE 1524

main(int argc, char * argv[]) {
  char localhost[] = "localhost";
  int writesocket; 
  char message[MESSAGE_SIZE];
  struct sockaddr_in incomming;
  int readsocket = passivesock(DEFAULTPORT, PROTOCOLNAME, QUEUELENGTH);
  int addrlen = sizeof(incomming);  
  int size;
  
  if (argc == 2) {
      writesocket = connectsock(argv[1], DEFAULTPORT, PROTOCOLNAME);
    fprintf(stdout,"sending data to %s at port %d using %s\n",
	    argv[1], DEFAULTPORT, PROTOCOLNAME);
  } else {
    writesocket = connectsock(localhost, DEFAULTPORT, PROTOCOLNAME);    
    fprintf(stdout,"sending data to %s at port %d using %s\n",
	    localhost, DEFAULTPORT, PROTOCOLNAME);
  }
  bzero(&incomming,sizeof(struct sockaddr_in));
  if (writesocket < 0) {
   fprintf(stderr,
	    "unknown error getting write socket\n",
	    PROTOCOLNAME);
    exit(-1);    
  } 
  if (readsocket < 0) {
    fprintf(stderr,
	    "unknown error reading from socket (%d)\n",
	    socket);
    exit(-1);    
  }
  while (size = recvfrom(readsocket, message, MESSAGE_SIZE, 0,
			 (struct sockaddr * )&incomming, &addrlen)) {
    message[size]='\0';
    /*    printf("%s\n", message);        */
    send(writesocket, message, strlen(message),0); 
    bzero(&incomming,sizeof(struct sockaddr_in));
  }
  close(readsocket);
  close(writesocket);
}


