/**
 * Sender sends input from the console to a UDP listener. 
 * First argument given is the target host.
 * @file gnet/network/testing/sender.c
 * @author Christian Grothoff
 * @author Larry Waldo
 **/


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <stdio.h>
#include <string.h>

#include "network.h"

#define MESSAGE_SIZE 1524

main(int argc, char * argv[]) {
  char localhost[] = "localhost";
  char message[MESSAGE_SIZE];
  int socket;
  int sendCount = 0;

  if (argc == 2) {
    socket = connectsock(argv[1], DEFAULTPORT, PROTOCOLNAME);
    fprintf(stdout,"sending data to %s at port %s using %s\n",
	    argv[1], DEFAULTPORT, PROTOCOLNAME);
  } else {
    socket = connectsock(localhost, DEFAULTPORT, PROTOCOLNAME);
    fprintf(stdout,"sending data to %s at port %s using %s\n",
	    localhost, DEFAULTPORT, PROTOCOLNAME);
  }
  if (socket < 0) {
   fprintf(stderr,
	    "unknown error getting socket\n",
	    PROTOCOLNAME);
    exit(-1);    
  }
  bzero(message, MESSAGE_SIZE);
  scanf("%s", message);    
  while(message[0] != '.') {
    printf("sending <%s>\n",message); 
    send(socket, message, strlen(message),0);
    bzero(message, MESSAGE_SIZE);
    sendCount++;
    if ((sendCount % 10000) == 0)
      fprintf(stderr,".");
    scanf("%s", message); 
  } 
  close(socket);
}
