/**
 * @file gproxy/DownloadFrame.java
 **/
package gproxy;

import javax.swing.JScrollPane;

/**
 * This is the class representing the Download window of the
 * GProxy GUI.
 * @author Christian Grothoff
 **/
public class DownloadFrame 
    extends javax.swing.JFrame {

    /**
     * The download model of this frame.
     **/
    private final DownloadModel dlm_;

    /**
     * The currently displayed list.
     **/
    private final javax.swing.JList downloadList;

    /** 
     * Create a new Download Window.
     **/
    public DownloadFrame(DownloadModel dlm) {
	this.dlm_ = dlm;
	// init JFrame
        getContentPane().setLayout(new java.awt.BorderLayout());        
        setTitle("GProxy: Download");        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing
		(java.awt.event.WindowEvent evt) {
		dlm_.windowClosed();
            }
        }); 
	// init components
	javax.swing.JButton abortButton 
	    = new javax.swing.JButton();
	abortButton.setToolTipText("click here to abort selected file");
        abortButton.setText("abort");        
	downloadList = new javax.swing.JList(dlm);
	abortButton.addActionListener
	    (new java.awt.event.ActionListener() {
            public void actionPerformed
		(java.awt.event.ActionEvent evt) {
		// go to search-list, find matching RootNode
		int[] selected = downloadList.getSelectedIndices();
		dlm_.abort(selected);
            }
        });        
        getContentPane().add
	    (abortButton, java.awt.BorderLayout.NORTH);
   	downloadList.setForeground(java.awt.Color.black);
        downloadList.setBackground(java.awt.Color.gray);
	JScrollPane scrollPane 
	    = new JScrollPane(downloadList);
	getContentPane().add
	    (scrollPane, java.awt.BorderLayout.CENTER);

	pack();
	setSize(600,200);
        setVisible(true);
    }


} // end of DownloadFrame
